<template>
    <div class="edit-view">
        <el-form :model="formData" :rules="rules" ref="form" label-width="77px" label-position="right" size="small"
                 style="max-width: 500px;">
            <el-form-item prop="type" label="类型">
                <el-select v-model="formData.type" clearable filterable placeholder="请选择">
                    <el-option
                            v-for="item in typeOptions"
                            :key="item.value"
                            :label="item.label"
                            :value="item.value">
                    </el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="rule" label="规则">
                <el-input v-model="formData.rule"></el-input>
            </el-form-item>
            <el-form-item prop="ruleUnit" label="规则单位">
                <el-input v-model="formData.ruleUnit"></el-input>
            </el-form-item>
            <el-form-item prop="value" label="值">
                <el-input v-model="formData.value"></el-input>
            </el-form-item>
            <el-form-item prop="valueUnit" label="值单位">
                <el-input v-model="formData.valueUnit"></el-input>
            </el-form-item>
            <el-form-item prop="description" label="描述">
                <el-input v-model="formData.description"></el-input>
            </el-form-item>
            <el-form-item prop="multivalued" label="可多值">
                <el-switch v-model="formData.multivalued"></el-switch>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving"
                           type="primary">保存
                </el-button>
                <el-button @click="onDelete" :loading="saving"
                           type="danger" v-if="formData.id">删除
                </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
    export default {
        name: 'DeliveryFeeEdit',
        created() {
            if (this.$route.query.id) {
                this.$http
                    .get('deliveryFee/get/' + this.$route.query.id)
                    .then(res => {
                        this.formData = res;
                    })
                    .catch(e => {
                        console.log(e);
                        this.$message.error(e.error);
                    });
            }
        },
        data() {
            return {
                saving: false,
                formData: {},
                rules: {},
                typeOptions: [{"label": "起送距离和费用", "value": "BASE_FEE"},
                    {"label": "超出距离和费用", "value": "EXCESS_COST"},
                    {"label": "繁忙系数", "value": "BUSYNESS_FACTOR"},
                    {"label": "繁忙分钟", "value": "BUSY_MINUTES"},
                    {"label": "时间段系数", "value": "TIME_COEFFICIENT"},
                    {"label": "配送件数", "value": "NUMBER_OF_DELIVERY"}],
            }
        },
        methods: {
            onSave() {
                this.$refs.form.validate((valid) => {
                    if (valid) {
                        this.submit();
                    } else {
                        return false;
                    }
                });
            },
            submit() {
                let data = {...this.formData};

                this.saving = true;
                this.$http
                    .post('/deliveryFee/save', data, {body: 'json'})
                    .then(res => {
                        this.saving = false;
                        this.$message.success('成功');
                        this.$router.go(-1);
                    })
                    .catch(e => {
                        console.log(e);
                        this.saving = false;
                        this.$message.error(e.error);
                    });
            },
            onDelete() {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/deliveryFee/del/${this.formData.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                }).catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                })
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
